local mnu
--[[
   :
	.value
  -          - Update():
	.valGet = function(item) or table[item.name]
	-     .value
   :
	.valOnSet = function(item)
	       (     )

     :
1.     -   
	.valLabels = function(item) or table[item.value]
	-    
	VAL = 
2.       VAL  SetFormat():
	.valFormats = table[VAL]
3.     (    ):
	.valShapes = function(VAL) or table[VAL]
	-      :SetVal()

   :
	.label -  
	.labelShapes = function(label) or table[label]
	-   -   

            :
	if item.valGet then
	elseif item.parent.valGet then
	end
	if item.labelShapes then
	elseif item.parent.labelShapes then
	end

     -        :
	.onClick = function( item )

	---          /   
	local onClick = item.onClick or item.valOnSet or obj.valOnSet or obj.onClick
	if onClick then onClick( item, pars ) end

]]
local function valGet(item)
	local val = get_PS( item.name )
	item.parent:ItemFade( item, val == OFF and 0.7 or 1)
	return val
end

local function valOnSet( item )

	local n, v = item.name, item.value
	set_PS(n, v)

	if type(v) ~= "table" then
		--LogToChat(n.." = "..v)
		item.parent:ItemFade( item, v == OFF and 0.7 or 1)
	else
		LogToChat("see mods.txt")
		exObj( n, v )
	end
end
-------------------------------------------------------------------------------
function mainMenuToggle( pars )
	if mnu then
		---exObj("pars",pars)
		if not DnD:isSetted( mnu.wtMenu ) then
			---           , 
			---   
			wtChain( mnu.wtMenu, pars.reaction.widget , 10, 10 )
		end
		mnu:Show( true )
	else ---LogInfo("mainMenu.ShowToggle - mnu = nil")
	end
end
----------------------------------------------------------------
------ INIT
----------------------------------------------------------------
function menuUpdate()
	if mnu then mnu:Update() end
end

---  ,       
local onoff = { ON, OFF }
local valLabels = {
	[ON] = "ON",
	[OFF] = "OFF",
    }
local valFormats = { 
	--[names[NEED]] =	"<html alignx='right' fontsize='14'><tip_red><r name='value'/></tip_red></html>",
	--[names[GREED]] =	"<html alignx='right' fontsize='14'><tip_green><r name='value'/></tip_green></html>",
	--[names[SAME]] =	"<html alignx='right' fontsize='14'><tip_golden><r name='value'/></tip_golden></html>",
	--[Labels[PASS]] =	"<html alignx='right' fontsize='14'><tip_blue><r name='value'/></tip_blue></html>",
	[valLabels[ON]] =		"<html alignx='right' fontsize='14'><tip_green><r name='value'/></tip_green></html>",
	[valLabels[OFF]] =	"<html><log_dark_white><body alignx='right' fontsize='14'><r name='value'/></body></log_dark_white></html>",
	}
local alignVals = { 0, 1, 2 }
local alignLabels = { [0] = "Right", [1] = "Left", [2] = "Center" }
local PSnames = { 
		{ t = "_", l = "ALLIES"},
		{ n = "allies", l = "Show"},
			{ n = "a_name", l = "Show Name", o = 15},
			{ n = "a_health", l = "Show Health Bar", o = 15},
			{ n = "a_level", l = "Show Level", o = 15},
			{ n = "a_title", l = "Show Title", o = 15},
			{ n = "a_class", l = "Show Class", o = 15},
			{ n = "a_targName", l = "Show Target Name", o = 15},
			{ n = "a_sizeX", l = "Size X", type = "_edl" },
			{ n = "a_sizeY", l = "Size Y", type = "_edl" },
			{ n = "a_widthHP", l = "Width HP bar", type = "_edl" },

		{ t = "_", l = "ENEMIES"},
		{ n = "enemies", l = "Show"},
			{ n = "e_name", l = "Show Name", o = 15},
			{ n = "e_health", l = "Show Health Bar", o = 15},
			{ n = "e_level", l = "Show Level", o = 15},
			{ n = "e_title", l = "Show Title", o = 15},
			{ n = "e_class", l = "Show Class", o = 15},
			{ n = "e_targName", l = "Show Target Name", o = 15},
			{ n = "e_sizeX", l = "Size X", type = "_edl" },
			{ n = "e_sizeY", l = "Size Y", type = "_edl" },
			{ n = "e_widthHP", l = "Width HP bar", type = "_edl" },

		{ t = "_", l = "MOBS"},
		{ n = "mobs", l = "Show"},
			{ n = "m_name", l = "Show Name", o = 15},
			{ n = "m_health", l = "Show Health Bar", o = 15},
			{ n = "m_level", l = "Show Level", o = 15},
			{ n = "m_title", l = "Show Title", o = 15},
			{ n = "m_quality", l = "Show Quality", o = 15},
			{ n = "m_targName", l = "Show Target Name", o = 15},
			{ n = "m_sizeX", l = "Size X", type = "_edl" },
			{ n = "m_sizeY", l = "Size Y", type = "_edl" },
			{ n = "m_widthHP", l = "Width HP bar", type = "_edl" },

		{ t = "_", l = "NPC"},
		{ n = "npc", l = "Show"},
			{ n = "n_name", l = "Show Name", o = 15},
			{ n = "n_health", l = "Show Health Bar", o = 15},
			{ n = "n_level", l = "Show Level", o = 15},
			{ n = "n_title", l = "Show Title", o = 15},
			{ n = "n_quality", l = "Show Quality", o = 15},
			{ n = "n_targName", l = "Show Target Name", o = 15},
			{ n = "n_sizeX", l = "Size X", type = "_edl" },
			{ n = "n_sizeY", l = "Size Y", type = "_edl" },
			{ n = "n_widthHP", l = "Width HP Bar", type = "_edl" },

		{ t = "_", l = "COMMON"},
		{ n = "clr_name", l = "Color Players Names as Class"},
		{ n = "alignX_name", l = "Align by X for Names", listVals = alignVals, valLabels = alignLabels, def = "-" },
		{ n = "plcClassAsQuality", l = "Place Class As Quality", def = OFF},
		{ n = "plcQualityAsClass", l = "Place Quality As Class", },

	}

local function repaint()
	common.StateUnloadManagedAddon( "UserAddon/"..ADDONname )
	common.StateLoadManagedAddon( "UserAddon/"..ADDONname )
end
local function toConfig_RE()
	toConfig()
	repaint()
end
local function fromConfig_RE()
	fromConfig()
	repaint()
end
local function reset_PS_RE()
	reset_PS()
	repaint()
end

function GUIinit()
	local strucMenu = 
	{
		{ token = "_", label = "COMMANDS", },
		{ name = "load", label = "Load Settings", cmd=1, onClick = fromConfig_RE },
		{ name = "save", label = "Save Settings", cmd=1, onClick = toConfig_RE },
		{ token = "_", label = "SETTINGS", },
		--[[{ name = "locz", label = "Localize", valOnSet = setLocalize,
			type = "_txt", menuItems = loczList, offset = 15,
			tip = "" },


		{ name = "sjunk", label = "Auto Sell Junk",
			type = "_txt", valLabels = names, listVals = onoff },
		{ name = "wjunk", label = "Wipe Junk Cheaper",
			type = "_edl", chars=3, tip=L("Wipe junk items if its selling cost less then value") },
		{ name ="AUTOTARGETlist", label = "AUTOTARGET List", type ="_lst", 
			list = {
				itemSizeX = 300,
				type = "_txt", labels = allTypes, vals = sortVals, valLabels = names, defaultVal = SORT_ASC,
				edited = true, ---   
				numberKeys = true, ---      -          
				},
			offset = 15, tip = L("        ") },
		]]
	}
	---table.sort( PSnames, function( A, B ) return A.l < B.l end )
	for _, v in PSnames do
		if v.n then
			if v.type == "_edl" then
			table.insert(strucMenu, { name = v.n, label = v.l, offset=v.o, type = v.type, chars = 4 } )
			else
				table.insert(strucMenu, { name = v.n, label = v.l, offset=v.o, type = "_txt",
					defaultVal = v.def or ON, valLabels = v.valLabels or valLabels, listVals = v.listVals or onoff } )
			end
		else
			table.insert(strucMenu, { token = v.t, label = v.l } )
		end
	end
	addTable(strucMenu, {
		{ token = "_3", label = "Other Settings", },
		{ name = "gpSizeY", label = "Group HPBar size",	type = "_edl", chars=3 },
		{ name = "rdSizeY", label = "Raid HPBar size",	type = "_edl", chars=3 },
		{ token = "_", label = "", },
		--   { name = "repaint", label = "REPAINT", cmd=1, onClick = repaint },
		{ token = "_3", label = "------***------", },
		{ name = "prior", label = "Inteface Priority", type = "_edl", chars=5 },
		{ name = "reset", label = "Reset to Config.txt", cmd=1, onClick = reset_PS_RE },
		{ name ="listTexts", label =L("list Texts to mod.txt"), onClick = listTexts, tip="for translation - use after showing the entire interface" },
	} )

	mnu = menu{ strucMenu = strucMenu, priority = 500, mouse_overRun = true, fadeOn = 100, fadeOff = 600,
		valGet = valGet, ---       
		labelShapes = L, ---  
		valOnSet = valOnSet, --- ,         
		valFormats = valFormats, ---   ( ...)   
		valShapes = L, ---  
		itemSizeX = 300,
	}
	mnu:init({})
	DnD:Init( mnu.wtMenu, mnu.wtMenu, true)

end

