function toConfig()
	local cfg = {}
	for k, v in get_PS() do
		if not PS[k] or PS[k] ~= v then
			---       config.txt  
			---     user.cfg
			cfg[k] = v
		end
	end
	userMods.SetGlobalConfigSection( ADDONname, cfg )
	--exObj("PS saved", _PS)
	LogToChat(L("saved"))
end

function fromConfig()
	reset_PS()
	local cfg = userMods.GetGlobalConfigSection( ADDONname ) or {}
	for k, v in cfg do
		set_PS(k, v)
	end
	--exObj("PS loaded", _PS)
	LogToChat(L("loaded"))

end

local unloadedAddonsList = { "ContextOvertip" }
function loadUnloadedAddons( on )
	if on == true then
		for _, v in unloadedAddonsList do
			common.StateUnloadManagedAddon( v )
			LogToChat(v..L(" was unloaded"))
		end
	else
		for _, v in unloadedAddonsList do
			common.StateLoadManagedAddon( v )
			LogToChat(v..L(" was loaded"))
		end
	end

end

-----------------------------------------
---------------- INIT -------------------
-----------------------------------------
function mainInit()
	---         AddonsMenu  
	---         

	---    config.txt
	reset_PS()
	fromConfig()

	GUIinit()
	
	loadUnloadedAddons( true )
	InitNPB2()

	--[[
	          
	   -          
	]]

	LogToChat( L("started"), "LogColorGreen" )

end
